﻿namespace MycroForge.CLI.Commands.Attributes;

public class RequiresFeatureAttribute : Attribute
{
    public string FeatureName { get; }

    public RequiresFeatureAttribute(string featureName)
    {
        FeatureName = featureName;
    }

    public void RequireFeature(string command)
    {
        if (!Directory.Exists(Path.Join(Environment.CurrentDirectory, FeatureName)))
            throw new($"Command '{command}' requires feature {FeatureName}");
    }
}