﻿namespace MycroForge.CLI.Commands.Attributes;

public class RequiresVenvAttribute : Attribute
{
    public string Path => System.IO.Path.Join(Environment.CurrentDirectory, ".venv");

    public void RequireVenv(string command)
    {
        if (!File.Exists(System.IO.Path.Join(Environment.CurrentDirectory, Path)))
            throw new($"Command '{command}' requires directory {Path}");
    }
}