﻿using MycroForge.Core;

namespace MycroForge.CLI.Commands;

public partial class MycroForge
{
    public partial class Init
    {
        public class Options
        {
            public string Name { get; set; } = string.Empty;
            public IEnumerable<string>? Without { get; set; }
            public int? ApiPort { get; set; }
            public int? DbhPort { get; set; }
            public int? DbuPort { get; set; }
            public ProjectConfig.DbConfig.DbuPlatformOptions DbuPlatform { get; set; }

            public Features.Api.Options ApiOptions => new()
            {
                ApiPort = ApiPort <= 0 ? 8000 : ApiPort
            };

            public Features.Db.Options DbOptions => new()
            {
                DbhPort = DbhPort <= 0 ? 5050 : DbhPort,
                DbuPort = DbuPort <= 0 ? 5051 : DbhPort,
                DbuPlatform = DbuPlatform
            };
        }
    }
}